"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@cuillere/core");
const postgres_1 = require("@cuillere/postgres");
exports.CuillerePostgresApolloPlugin = (options, transactionOptions) => {
    var _a;
    const provider = (_a = options.poolProvider) !== null && _a !== void 0 ? _a : new postgres_1.PoolProvider(...options.poolConfigs);
    return ({
        requestDidStart() {
            let shouldRollback = false;
            return {
                didEncounterErrors() { shouldRollback = true; },
                executionDidStart({ context }) {
                    const manager = new postgres_1.TransactionManager(provider, transactionOptions);
                    postgres_1.setQueryHandler(context, query => manager.query(query));
                    context.getClient = (pool) => manager.getClient(pool);
                    return () => (shouldRollback ? manager.rollback() : manager.commit());
                },
            };
        },
    });
};
const getClientImpl = async function* getClient(name) {
    const getClientFn = yield core_1.get('getClient');
    return getClientFn(name);
};
exports.getClient = (name) => core_1.call(getClientImpl, name);
//# sourceMappingURL=index.js.map